!! Program to test the Savitzky Golay filter subroutines

program SG_main

	use Savitzky_Golay

	implicit none

	integer, parameter :: NMAX=1000 
	integer, parameter :: NTEST=6 

	integer :: i,j,m,nl,np,nr
	real :: sum
	real,dimension(:),allocatable :: c 
	integer,dimension(NTEST) :: mtest=(/2,2,2,2,4,4/)
	integer,dimension(NTEST) :: nltest=(/2,3,4,5,4,5/)
	integer,dimension(NTEST) :: nrtest=(/2,1,0,5,4,5/)
	character(len=78),dimension(NTEST) :: ans=(/ &
&'                     -0.086  0.343  0.486  0.343 -0.086                     ',&
&'              -0.143  0.171  0.343  0.371  0.257                            ',&
&'        0.086 -0.143 -0.086  0.257  0.886                                   ',&
&'-0.084  0.021  0.103  0.161  0.196  0.207  0.196  0.161  0.103  0.021 -0.084',&
&'        0.035 -0.128  0.070  0.315  0.417  0.315  0.070 -0.128  0.035       ',&
&' 0.042 -0.105 -0.023  0.140  0.280  0.333  0.280  0.140 -0.023 -0.105  0.042'&
& /)

	allocate(c(NMAX))
	write(0,*)'M nl nr'
	write(0,*)'				Sample Savitzky-Golay Coefficients'
	do i=1,NTEST
		m=mtest(i)
		nl=nltest(i)
		nr=nrtest(i)
		np=nl+nr+1
		call savgol(c,np,nl,nr,0,m,0)
		sum=0.0
		do j=1,np
			sum=sum+c(j)
		end do
		write(0,10) m,nl,nr
		!write(0,11) (' ',j=nl,4)
		write(0,12) (c(j), j=nl+1,1,-1)
		write(0,12) (c(np-j), j=0,nr-1)
		write(0,*)''
		write(0,13) sum
		write(0,14) ans(i)
	end do

10	FORMAT ( 1X,I1,1X,I1,1X,I1 )
11  FORMAT ( 1X,7X )
12	FORMAT ( 1X,F7.3 ) 
13	FORMAT ( 1X,'sum=',F7.3 )
14	FORMAT ( 1X,'Compare answer:',A )

	end program SG_main
