!! simple program to create a 1-D history file with a constant value
!! usage:
!!	create1d.x n1= amplitude= > out.H
!!
program create1d
	use sep

	implicit none

	integer									:: n1
	real									:: amplitude
	real,dimension(:),allocatable			:: data
 
	!! hook up SEP stuff and get parameters from input history file
	call sep_init ()
	call from_param ("n1",n1)
	call from_param("amplitude",amplitude,1.0)

	!! write parameters to output history file
	call to_history ("esize",4)
	call to_history ("n1",   n1)
	call to_history ("n2",   1)
	call to_history ("n3",    1)
	call sep_close ()

	!! allocate working space
	allocate (data(n1))
	data=amplitude

	! read input 1-D array, scale and output it
	call srite("out",data,4*size(data))
	
	deallocate (data)

	call exit (0)

end program create1d
