!! simple program to read a 1-D history file and compute two files: one with
!! x percent grater values and the other with y percent lower values. Optionally
!! a hard maximum and minimum value may also be provided
!! usage:
!!	maxmin.x < in.H max= min= percmax= percmin= parmin= parmax= > /dev/null
!!
program maxmin
	use sep

	implicit none

	integer									:: n1,i
	real									:: max,min,percmax,percmin,scale
	real,dimension(1)						:: tmp
	real,dimension(:),allocatable			:: data,data_aux,log
 
	!! hook up SEP stuff and get parameters from input history file
	call initpar ()
	call from_param("max",max,0.0)
	call from_param("min",min,0.0)
	call from_param("percmax",percmax,0.0)
	call from_param("percmin",percmin,0.0)
	call from_param("n1",n1,99)

	!! allocate working space
	allocate (data(n1))

	!! write parameters to output history files
	call to_history ("esize",4,"parmin"); call to_history("esize",4,"parmax")
	call to_history ("n2",   1,"parmin"); call to_history("n2",1,"parmax")
	call to_history ("n3",   1,"parmin"); call to_history("n3",1,"parmax")
	call to_history ("o1",   0,"parmin"); call to_history("o1",0,"parmax")

	! output the maximum and minimum files
	if (percmax==0 .AND. percmin==0) then

		call to_history ("n1",n1,"parmin"); call to_history("n1",n1,"parmax")
		call sep_close ()
		data=max
		call srite("parmax",data,4*size(data))
		data=min
		call srite("parmin",data,4*size(data))

	else if (max==0 .AND. min==0) then

		!! allocate working space
		allocate (data_aux(n1),log(n1))

		call to_history ("n1", n1,"parmin"); call to_history("n1",n1,"parmax")
		call sep_close ()
		call sreed("sg", data,4*size(data))
		call sreed("log", log,4*size(log))

		scale=1.+percmax/100
		tmp=maxval(log)
		data_aux=scale*data
		do i=1,n1
			if (data(i)>tmp(1)) data_aux(i)=tmp(1)
		end do
		call srite("parmax",data_aux,4*size(data))
		scale=1.-percmin/100
		tmp=minval(log)
		data_aux=scale*data
		do i=1,n1
			if (data(i)<tmp(1)) data_aux(i)=tmp(1)
		end do
		call srite("parmin",data_aux,4*size(data))

		!! clean up
		deallocate (data_aux,log)
	else
		write(0,*)'ERROR: either max==0 and min==0 or percmax==0 and percmin==0'
	end if
		
	!! clean up
	deallocate (data)

	call exit (0)

end program maxmin
