!! simple program to scale an input 1-D history file dataset
!! usage:
!!	myscale1d.x < in.H scale= > out.H
!!
program myscale1d
	use sep

	implicit none

	integer									:: n1
	real									:: scale
	real,dimension(:),allocatable			:: data
 
	!! hook up SEP stuff and get parameters from input history file
	call sep_init ()
	call from_history (n1)
	call from_param("scale",scale,1.0)

	!! write parameters to output history file
	call to_history ("esize",4)
	call to_history ("n1",   n1)
	call to_history ("n2",   1)
	call to_history ("n3",    1)
	call to_history ("esize", 4)
	call sep_close ()

	!! allocate working space
	allocate (data(n1))

	! read input 1-D array, scale and output it
	call sreed("in", data,4*size(data))
	call srite("out",scale*data,4*size(data))
	
	deallocate (data)
	call exit (0)
end program myscale1d
